;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_INITIALISIERUNG:
	; DCF-EINGANG						
	cbi (DCF_DDR) ,(DCF_PIN_NR) ; auf EINGANG
	cbi (DCF_PORT),(DCF_PIN_NR) ; PULL UP aus, wichtig, denn manche DCF-Module sehr hochohmig !
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_AUTO_INVERTIERMODUS_ERKENNUNG:
	; Programm-VOREINSTELLUNG abfragen		
	ldi temp,(DCF_EINGANG_VOREINSTELLUNG_INVERTIEREN)
	cpi temp,0
	breq DCF_AUTO_INVERTIERMODUS_ERKENNUNG_NICHT_INVERTIEREN
	cpi temp,1
	breq DCF_AUTO_INVERTIERMODUS_ERKENNUNG_INVERTIEREN
	cpi temp,255
	breq DCF_AUTO_INVERTIERMODUS_ERKENNUNG_RUN
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_NICHT_INVERTIEREN:
	STS(adr_DCF_PIN_INVERTIERMODUS),NULL
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_INVERTIEREN:
	STS(adr_DCF_PIN_INVERTIERMODUS),EINS
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_RUN:
	; DCF erfolgreich ?						
	LDS temp,(adr_DCF_ERFOLGREICH)
	tst temp
	breq DCF_AUTO_INVERTIERMODUS_ERKENNUNG_w0
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_w0:
	; Taste gedrckt ?						
	LDS temp,(adr_TASTE)
	tst temp
	breq DCF_AUTO_INVERTIERMODUS_ERKENNUNG_w1
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_w1:
	; Impulslnge >= 50ms ?					
	LDS temp,(adr_DCF_PIN_WERT_OLD)
	cpi temp,5
	brsh DCF_AUTO_INVERTIERMODUS_ERKENNUNG_w2
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_w2:
	; Impulslnge <= 95ms ?					
	cpi temp,95
	brlo DCF_AUTO_INVERTIERMODUS_ERKENNUNG_w3
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_w3:
	; Impulslnge >= 300ms ?				
	cpi temp,30
	brsh DCF_AUTO_INVERTIERMODUS_ERKENNUNG_MODUS_WECHSEL
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_MODUS_WECHSEL:
	; Modus Wechseln, von invertiert auf nicht invertiert, oder umgekehrt	
	LDS temp,(adr_DCF_PIN_INVERTIERMODUS)
	tst temp
	breq DCF_AUTO_INVERTIERMODUS_ERKENNUNG_MODUS_WECHSEL_w
	STS(adr_DCF_PIN_INVERTIERMODUS),NULL
	ret
DCF_AUTO_INVERTIERMODUS_ERKENNUNG_MODUS_WECHSEL_w:
	STS(adr_DCF_PIN_INVERTIERMODUS),EINS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Einige Aktionen durchfhren, wenn das DCF Signal das 1.mal erfolgreich empfangen wurde
DCF_BESTIMMUNG_ERFOLGREICH:
	LDS temp,(adr_DCF_ERFOLGREICH)
	tst temp
	breq DCF_BESTIMMUNG_ERFOLGREICH_RUN
	ret
DCF_BESTIMMUNG_ERFOLGREICH_RUN:
	; NULL ?		
	LDS temp,(adr_ss100)
	tst temp
	breq DCF_BESTIMMUNG_ERFOLGREICH_CHECK
	ret
DCF_BESTIMMUNG_ERFOLGREICH_CHECK:
	; DCF gltig ?	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	brne DCF_BESTIMMUNG_ERFOLGREICH_START
	ret
DCF_BESTIMMUNG_ERFOLGREICH_START:
	; NULL									
	STS(adr_DCF_ERROR_CODE),NULL
	; EINS									
	STS((adr_DCF_ERFOLGREICH)),EINS
	; RELAIS_KLICK							
	rcall RELAIS_KLICK
	; EEPROM_KONFIGURATION_SPEICHERN		
	rcall EEPROM_KONFIGURATION_SPEICHERN
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_UHR:
	rcall DCF_PIN_ABFRAGEN_TEMP1
	rcall DCF_PHASENLAGE_TEMP1
	rcall DCF_PHASENKORREKTUR_TEMP1
	rcall DCF_LED_TEMP1
	rcall DCF_SAMPLES_A_B_TEMP1
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; DCF77-TRGER=ON=MODULAUSGANG=5V (NORMAL)									
; DCF77-TRGER=ON=MODULAUSGANG=0V (INVERTIERT)								
; Abtastung erfolgt 100 mal pro Sekunde										
; LED GELB muss leuchten, wenn DCF77 Trger ausgetastet ist					
; OUT: temp1 (1=77kHz-TRGER=off)											
DCF_PIN_ABFRAGEN_TEMP1:
	; INVERTIERMODUS ?	
	LDS temp,(adr_DCF_PIN_INVERTIERMODUS)
	tst temp
	brne DCF_PIN_ABFRAGEN_TEMP1_NORMAL
	rjmp DCF_PIN_ABFRAGEN_TEMP1_INVERTIERT

DCF_PIN_ABFRAGEN_TEMP1_INVERTIERT:
	; PIN abfragen		
	sbic DCF_PIN,DCF_PIN_NR	; springe, wenn...
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_OFF
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_ON
DCF_PIN_ABFRAGEN_TEMP1_NORMAL:
	; PIN abfragen		
	sbic DCF_PIN,DCF_PIN_NR	; springe, wenn...
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_ON
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_OFF
DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_OFF:
	clr temp1					; temp1=0=LED off	
	ret
DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_ON:
	ldi temp1,1					; temp1=1=LED on	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; OUT: temp1 (1=77kHz-TRGER=off)											
DCF_PHASENLAGE_TEMP1:
	LDS temp,(adr_DCF_PIN_WERT)
	add temp,temp1
	STS(adr_DCF_PIN_WERT),temp
	; PEGEL=1 ?					
	tst temp1
	brne DCF_PHASENLAGE_TEMP1_w
	; OLD speichern				
	STS(adr_DCF_IMPULS_OLD),temp1
	ret
DCF_PHASENLAGE_TEMP1_w:	
	; PEGEL-OLD laden					
	LDS temp,(adr_DCF_IMPULS_OLD)
	; OLD <> momentaner PEGEL ?
	cp temp,temp1
	breq DCF_PHASENLAGE_TEMP1_ww
	; Pegelwechsel erkannt - PHASE speichern		
	LDS temp,(adr_ss100)	
	STS(adr_DCF_IMPULS_PHASE),temp
DCF_PHASENLAGE_TEMP1_ww:	
	; OLD speichern				
	STS(adr_DCF_IMPULS_OLD),temp1
ret	
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; nur bei 50 wird die PHASE korrigiert										
DCF_PHASENKORREKTUR_TEMP1:
	; 100el=50 ?									
	LDS temp,(adr_ss100)
	cpi temp,50
	breq DCF_PHASENKORREKTUR_TEMP1_RUN
	ret
DCF_PHASENKORREKTUR_TEMP1_RUN:
	; Phase "0" (nicht schieben)					
	LDS temp,(adr_DCF_IMPULS_PHASE)
	tst temp
	brne DCF_PHASENKORREKTUR_TEMP1_NO_OK
	; PHASE-TIMER neu laden							
	ldi temp,(DCF_PHASE_TIMERWERT)
	STS(adr_DCF_PHASE_TIMER),temp
	ret
DCF_PHASENKORREKTUR_TEMP1_NO_OK:
	; hat PHASE-TIMER schon freigegeben ?			
	LDS temp,(adr_DCF_PHASE_TIMER)
	tst temp
	breq DCF_PHASENKORREKTUR_TEMP1_PT
	ret
DCF_PHASENKORREKTUR_TEMP1_PT:
	; PHASE-TIMER neu laden							
	ldi temp,(DCF_PHASE_TIMERWERT)
	STS(adr_DCF_PHASE_TIMER),temp
	; Phase "-2 -1" (100el-vorsichtig schieben)		
	LDS temp,(adr_DCF_IMPULS_PHASE)
	cpi temp, 98	
	brsh DCF_PHASENKORREKTUR_TEMP1_PLUS
	; Phase "+1 +2" (100el-vorsichtig schieben)		
	cpi temp,2+1
	brlo DCF_PHASENKORREKTUR_TEMP1_MINUS
	; DCF gltig, wenn ja alle Strungen ignorieren	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	breq DCF_PHASENKORREKTUR_TEMP1_NO_GUELTIG
	ret
DCF_PHASENKORREKTUR_TEMP1_NO_GUELTIG:
	; 100el auf PHASE 								
	LDS temp,(adr_DCF_IMPULS_PHASE)
	cpi temp,50
	brlo DCF_PHASENKORREKTUR_TEMP1_HART_MINUS
	breq DCF_PHASENKORREKTUR_TEMP1_HART_MINUS
	rjmp DCF_PHASENKORREKTUR_TEMP1_HART_PLUS
;---------------------------------------------------------------------------
DCF_PHASENKORREKTUR_TEMP1_HART_MINUS:
	; 50 minus PHASE			
	push temp1
	ldi temp1,50
	sub temp1,temp
	STS(adr_ss100),temp1
	pop temp1
	ret
;---------------------------------------------------------------------------
DCF_PHASENKORREKTUR_TEMP1_HART_PLUS:
	; 150 minus PHASE			
	push temp1
	ldi temp1,150
	sub temp1,temp
	STS(adr_ss100),temp1
	pop temp1
	ret
;---------------------------------------------------------------------------
DCF_PHASENKORREKTUR_TEMP1_PLUS:
	LDS temp,(adr_ss100)
	inc temp
	STS(adr_ss100),temp
	ret
;---------------------------------------------------------------------------
DCF_PHASENKORREKTUR_TEMP1_MINUS:
	LDS temp,(adr_ss100)
	dec temp
	STS(adr_ss100),temp
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; LED-GELB-AUSWERTUNG														
; INP/OUT: temp1															
DCF_LED_TEMP1:
	tst temp1	
	breq DCF_LED_TEMP1_OFF
	rjmp DCF_LED_TEMP1_ON
DCF_LED_TEMP1_ON:
	; soll LED blinken ?						
	ldi temp,(DCF_SIGNAL_LED_GELB_AN)
	tst temp
	brne DCF_LED_TEMP1_ON_w
	; LED blinkt, wenn DCF Signal nicht gltig	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	brne DCF_LED_TEMP1_OFF
DCF_LED_TEMP1_ON_w:
	cbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	 ; GELB-AN	
	ret
DCF_LED_TEMP1_OFF:
	sbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	 ; GELB-AUS	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;  00=WRITE (DCF-PROTOKOLL)												
;  01=Initialisierung													
;  02=SAMPLES-A															
;  03=SAMPLES-A															
;  04=SAMPLES-A															
;  05=SAMPLES-A															
;  06=SAMPLES-A															
;  07=SAMPLES-A															
;  08=SAMPLES-A															
;  09=nix																
;  10=nix																
;  11=nix																
;  12=nix																
;  13=nix																
;  14=nix																
;  15=nix																
;  16=nix																
;  17=SAMPLES-B															
;  18=SAMPLES-B															
;  19=SAMPLES-B															
;  20=SAMPLES-B															
;  21=SAMPLES-B															
;  22=SAMPLES-B															
;  23=nix																
;  ..																	
;  99=nix																
;																		
DCF_SAMPLES_A_B_TEMP1:
	sbi (LED_DCF_BLAU_PORT),(LED_DCF_BLAU_PIN_NR)	; DCF-BLAU	
	; ZEIGER laden		
	LDS temp,(adr_ss100)
	; WRITE				
	cpi temp,0							; 0			
	breq DCF_SAMPLES_WRITE
	; Initialisierung	
	cpi temp,1							; 1			
	breq DCF_SAMPLES_A_B_INITIALISIERUNG
	; SAMPLES "A"		
	cpi temp,8+1						; 2...8		
	brlo DCF_SAMPLES_A
	; DUMMY				
	cpi temp,16+1						; 9...16	
	brlo DCF_SAMPLES_A_B_DUMMY
	; SAMPLES "B"		
	cpi temp,22+1						; 17...22	
	brlo DCF_SAMPLES_B
	breq DCF_MINUTEN_LED				; 23		
DCF_SAMPLES_A_B_DUMMY:
	ret
;---------------------------------------------------------------------------
DCF_SAMPLES_A_B_INITIALISIERUNG:
	STS(adr_DCF_SAMPLES_A),NULL
	STS(adr_DCF_SAMPLES_B),NULL
ret
;---------------------------------------------------------------------------
; SAMPLES "A"																
DCF_SAMPLES_A:
	cbi (LED_DCF_BLAU_PORT),(LED_DCF_BLAU_PIN_NR)	; DCF-BLAU	
	tst temp1
	brne DCF_SAMPLES_Aw
	ret
DCF_SAMPLES_Aw:
	STS(adr_DCF_SAMPLES_A),EINS
	ret
;---------------------------------------------------------------------------
; SAMPLES "B"																
DCF_SAMPLES_B:
	cbi (LED_DCF_BLAU_PORT),(LED_DCF_BLAU_PIN_NR)	; DCF-BLAU	
	tst temp1
	brne DCF_SAMPLES_Bw
	ret
DCF_SAMPLES_Bw:
	STS(adr_DCF_SAMPLES_B),EINS
	ret
;---------------------------------------------------------------------------
; kurzes aufleuchten der LED, wenn Minute erkannt							
DCF_MINUTEN_LED:
	LDS temp,(adr_DCF_SAMPLES_A)
	tst temp
	breq DCF_MINUTEN_LED_w
	ret
DCF_MINUTEN_LED_w:
	LDS temp,(adr_DCF_SAMPLES_B)
	tst temp
	breq DCF_MINUTEN_LED_ww
	ret
DCF_MINUTEN_LED_ww:
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_SAMPLES_WRITE:
	; Z-ZEIGER initialisieren			
	LDI ZL, low(adr_DCF_BEREICH)
	LDI ZH,high(adr_DCF_BEREICH)
	;"B" SAMPLES in's Datenfeld schreiben ("A"wird ignoriert)	
	LDS temp2,(adr_DCF_SAMPLES_B)
	STS(adr_DCF_BIT),temp2
	; addieren							
	LDS temp, (adr_DCF_ZEIGER)
	add ZL,temp
	adc ZH,NULL
	; DCF-BIT in's Datenfeld schreiben	
	ST Z,temp2
;---------------------------------------------------------------------------
	; DCF ZEIGER +1				
	LDS temp, (adr_DCF_ZEIGER)
	inc temp
	cpi temp,59+1
	brlo DCF_SAMPLES_WRITE_Z
	clr temp
DCF_SAMPLES_WRITE_Z:
	STS (adr_DCF_ZEIGER),temp
;---------------------------------------------------------------------------
	; MINUTENANFANG	A=B=0 ?				
	LDS temp,(adr_DCF_SAMPLES_A)
	LDS temp1,(adr_DCF_SAMPLES_B)
	; addieren					
	add temp,temp1
	; gleich NULL ?				
	tst temp
	breq DCF_SAMPLES_MINUTENANFANG
	ret
;---------------------------------------------------------------------------
; MINUTENANFANG erkannt														
DCF_SAMPLES_MINUTENANFANG:
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	aus
	; DCF schon mal erfolgreich ?
	LDS temp,(adr_DCF_ERFOLGREICH)
	tst temp
	brne DCF_SAMPLES_MINUTENANFANG_w
	; ZEIT auf NULL		
	STS(adr_ss),NULL
	STS(adr_mm),NULL
	STS(adr_hh),NULL
DCF_SAMPLES_MINUTENANFANG_w:
	; DCF gltig ?			
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	breq DCF_TURBO							; nein	
	; ZEIGER auf 0			
	LDS temp,(adr_DCF_ZEIGER)
	cpi temp,0
	breq DCF_SAMPLES_MINUTENANFANG_START	; ja	
	; ignorieren			
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	an
	; ERROR						
	ldi temp,(ERROR_DCF_STOERIMPULSE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_SAMPLES_MINUTENANFANG_START:
	rjmp DCF_MINUTENSTART_ZEIT_BERECHNUNG
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; Schnellstart (kein Komplettes DCF Protokoll erforderlich)					
DCF_TURBO:
	; Kein Turbo, wenn Zeiger 0
	LDS temp,(adr_DCF_ZEIGER)
	tst temp
	breq DCF_MINUTENSTART_ZEIT_BERECHNUNG
;---------------------------------------------------------------------------
DCF_TURBO_START:
	; Kein Turbo, bei zu wenig DCF Daten
	LDS temp, (adr_DCF_ZEIGER)
	cpi temp,42
	brsh DCF_TURBO_RUN
	; NULL						
	STS(adr_DCF_ZEIGER),NULL
	; ERROR						
	ldi temp,(ERROR_DCF_TURBO)
	STS(adr_DCF_ERROR_CODE),temp
	ret
;---------------------------------------------------------------------------
; das Datenfeld zurechtschieben												
DCF_TURBO_RUN:
	; Zeiger laden		
	LDS temp, (adr_DCF_ZEIGER)
	; Differenz bilden	
	ldi temp1,60
	sub temp1,temp
DCF_TURBO_w:
	rcall DATENFELD_1x_SCHIEBEN
	dec temp1
	brne DCF_TURBO_w
;---------------------------------------------------------------------------
	; NULL				
	STS(adr_DCF_ZEIGER),NULL
	; Initialisierung	
	STS(adr_DCF_BEREICH+0),NULL
rjmp DCF_MINUTENSTART_ZEIT_BERECHNUNG
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DATENFELD_1x_SCHIEBEN:
	; initialisieren	
	ldi temp2,59
	ldi ZL,LOW (adr_DCF_BEREICH+58-1)
	ldi ZH,HIGH(adr_DCF_BEREICH+58-1)
	; Schleife			
DATENFELD_SCHIEBEN_w:
	LD temp,Z	; laden		
	adiw ZL,1	; +1		
	ST Z,temp	; speichern	
	sbiw ZL,2	; -2		
	dec temp2
	brne DATENFELD_SCHIEBEN_w
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;Bit(s) Anzahl 		Bedeutung 												
; 0 	1 bit	Start einer neuen Minute (ist immer "0") 					
;16 				"1": Am Ende dieser Stunde wird MEZ/MESZ umgestellt. 	
;17 				"0": MEZ, "1": MESZ 									
;18 				"0": MESZ, "1": MEZ 									
;19 				"1": Am Ende dieser Stunde wird eine Schaltsekunde eingefgt. 
;20 		1 bit 	Beginn der Zeitinformation (ist immer "1") 				
;21-27 		7 bit 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 	
;28 		1 bit 	Paritt Minute 											
;29-34 		6 bit 	Stunde (1, 2, 4, 8, 10, 20) 							
;35 		1 bit 	Paritt Stunde 											
;36-41 		6 bit 	Monatstag (1, 2, 4, 8, 10, 20) 							
;42-44 		3 bit 	Wochentag (1, 2, 4) 									
;45-49 		5 bit 	Monat (1, 2, 4, 8, 10) 									
;50-57 		8 bit 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 			
;58 		1 bit 	Paritt Datum 											
DCF_MINUTENSTART_ZEIT_BERECHNUNG:
	STS(adr_DCF_GUELTIG),NULL						; DCF GUELTIG auf NULL setzen		
;---------------------------------------------------------------------------
	; DCF-Zeiger muss auf 0 stehen		
	LDS temp, (adr_DCF_ZEIGER)
	STS(adr_DCF_ZEIGER),NULL	; DCF-ZEIGER NULL	
	cpi temp,0
	breq DCF_MINUTENSTART_ZEIT_BERECHNUNG_RUN
	; ERROR								
	ldi temp,(ERROR_DCF_MINUTENSTART)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_MINUTENSTART_ZEIT_BERECHNUNG_RUN:
;---------------------------------------------------------------------------
;0 	Start einer neuen Minute (ist immer "0") 				
DCF_ZEIT_00:
	LDS temp,(adr_DCF_BEREICH+0)			; aus SRAM laden	
 	tst temp 
	breq DCF_ZEIT_00_OK
	; ERROR						
	ldi temp,(ERROR_DCF_NO_ANFANGSBIT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_00_OK:
;---------------------------------------------------------------------------
;1-14 Wetterdaten															
DCF_ZEIT_01:
;---------------------------------------------------------------------------
;15 Reserveantenne aktiv													
DCF_ZEIT_15:
	LDS temp,(adr_DCF_BEREICH+15)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_15_OK
	; ERROR	(als INFO)				
	ldi temp,(ERROR_DCF_RESERVEANTENNE)
	STS(adr_DCF_ERROR_CODE),temp
DCF_ZEIT_15_OK:
;---------------------------------------------------------------------------
;16 Umstellung von MEZ auf MESZ oder umgekehrt								
DCF_ZEIT_16:
	LDS temp,(adr_DCF_BEREICH+16)
	tst temp
	breq DCF_ZEIT_16_OK
	; ERROR	(als INFO)				
	ldi temp,(ERROR_DCF_ZEITUMSTELLUNG)
	STS(adr_DCF_ERROR_CODE),temp
DCF_ZEIT_16_OK:
;---------------------------------------------------------------------------
;17 SOMMERZEIT aktiv				"0": MEZ, "1": MESZ 					
DCF_ZEIT_17:
	LDS temp,(adr_DCF_BEREICH+17)
	STS (adr_DCF_MESZ),temp			; im SRAM ablegen	
;---------------------------------------------------------------------------
;18 NORMALZEIT aktiv				"1": MEZ, "0": MESZ 					
DCF_ZEIT_18:
	LDS temp1,(adr_DCF_BEREICH+18)
	; MEZ<>MESZ					
	add temp,temp1
	cpi temp,1
	breq DCF_ZEIT_18_OK
	; ERROR						
	ldi temp,(ERROR_DCF_MESZ)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_18_OK:
;---------------------------------------------------------------------------
;19 Ankndigung Schaltsekunde												
DCF_ZEIT_19:
	LDS temp,(adr_DCF_BEREICH+19)
	tst temp
	breq DCF_ZEIT_19_OK
	; ERROR						
	ldi temp,(ERROR_DCF_SCHALTSEKUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_19_OK:
;---------------------------------------------------------------------------
;20 Beginn der Zeitinformation (ist immer "1") 								
DCF_ZEIT_20:
	LDS temp,(adr_DCF_BEREICH+20)
 	tst temp 
	brne DCF_ZEIT_20_OK
	; ERROR-CODE			
	ldi temp,(ERROR_DCF_NO_ZEITINFORMATIONSBIT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_20_OK:
;---------------------------------------------------------------------------
;21-27 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 				
DCF_ZEIT_21:
	clr temp1	; BIT					
	clr temp2	; PARITT(berechnet)	
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+21)
	ldi ZH,HIGH(adr_DCF_BEREICH+21)
	rcall FUNCTION_DCF_BIT_01	; 21
	rcall FUNCTION_DCF_BIT_02	; 22
	rcall FUNCTION_DCF_BIT_04	; 23
	rcall FUNCTION_DCF_BIT_08	; 24
	rcall FUNCTION_DCF_BIT_10	; 25
	rcall FUNCTION_DCF_BIT_20	; 26
	rcall FUNCTION_DCF_BIT_40	; 27
	; MINUTENWERT bernehmen	
	STS(adr_DCF_mm),temp1
	; Fehlerprfung MINUTE 0...59
	cpi temp1,(59+1)
	brlo DCF_ZEIT_27_OK
	; ERROR						
	ldi temp,(ERROR_DCF_MINUTE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_27_OK:
;---------------------------------------------------------------------------
;28  	Paritt Minute 											
DCF_ZEIT_28:
	LDS temp,(adr_DCF_BEREICH+28)	; Paritt laden				
	cp temp,temp2					; Paritt vergleichen		
	breq DCF_ZEIT_28_OK
	; ERROR						
	ldi temp,(ERROR_DCF_PARITAET_MINUTE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_28_OK:
;---------------------------------------------------------------------------
;29-34 	 	Stunde (1, 2, 4, 8, 10, 20) 									
DCF_ZEIT_29:
	clr temp1	; BIT					
	clr temp2	; PARITT(berechnet)	
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+29)
	ldi ZH,HIGH(adr_DCF_BEREICH+29)
	rcall FUNCTION_DCF_BIT_01	; 29
	rcall FUNCTION_DCF_BIT_02	; 30
	rcall FUNCTION_DCF_BIT_04	; 31
	rcall FUNCTION_DCF_BIT_08	; 32
	rcall FUNCTION_DCF_BIT_10	; 33
	rcall FUNCTION_DCF_BIT_20	; 34
	; STUNDENWERT bernehmen		
	STS(adr_DCF_hh),temp1
	; Fehlerprfung STUNDE 0...23	
	cpi temp1,(23+1)
	brlo DCF_ZEIT_34_OK
	; ERROR							
	ldi temp,(ERROR_DCF_STUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_34_OK:
;---------------------------------------------------------------------------
;35 			Paritt Stunde 											
DCF_ZEIT_35:
	LDS temp,(adr_DCF_BEREICH+35)	; Paritt laden				
	cp temp,temp2					; Paritt vergleichen		
	breq DCF_ZEIT_35_OK
	; ERROR-CODE				
	ldi temp,(ERROR_DCF_PARITAET_STUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_35_OK:
;---------------------------------------------------------------------------
;36-41 		 	Monatstag (1, 2, 4, 8, 10, 20) 								
DCF_ZEIT_36:
	clr temp1	; BIT					
	clr temp2	; PARITT(berechnet)	
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+36)
	ldi ZH,HIGH(adr_DCF_BEREICH+36)
	rcall FUNCTION_DCF_BIT_01	; 36
	rcall FUNCTION_DCF_BIT_02	; 37
	rcall FUNCTION_DCF_BIT_04	; 38
	rcall FUNCTION_DCF_BIT_08	; 39
	rcall FUNCTION_DCF_BIT_10	; 40
	rcall FUNCTION_DCF_BIT_20	; 41
	; TAG bernehmen			
	STS(adr_DCF_TAG),temp1
	; Fehlerprfung TAG	1...31	
	tst temp1
	breq DCF_ZEIT_41_ERROR
	cpi temp1,(31+1)
	brlo DCF_ZEIT_41_OK
	; ERROR						
DCF_ZEIT_41_ERROR:
	ldi temp,(ERROR_DCF_TAG)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_41_OK:
;---------------------------------------------------------------------------
;42-44 		 	Wochentag (1, 2, 4) 										
DCF_ZEIT_42:
	clr temp1	; BIT					
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+42)
	ldi ZH,HIGH(adr_DCF_BEREICH+42)
	rcall FUNCTION_DCF_BIT_01	; 42
	rcall FUNCTION_DCF_BIT_02	; 43
	rcall FUNCTION_DCF_BIT_04	; 44
	; WOCHENTAG bernehmen		
	STS(adr_DCF_WOCHENTAG),temp1
	; Fehlerprfung WOCHENTAG 1=MO 1...7	
	tst temp1
	breq DCF_ZEIT_44_ERROR
	cpi temp1,(7+1)
	brlo DCF_ZEIT_44_OK
	; ERROR						
DCF_ZEIT_44_ERROR:
	ldi temp,(ERROR_DCF_WOCHENTAG)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_44_OK:
;---------------------------------------------------------------------------
;45-49 		 	Monat (1, 2, 4, 8, 10) 										
DCF_ZEIT_45:
	clr temp1	; BIT					
	; Z-ZEIGER						
	ldi ZL,LOW (adr_DCF_BEREICH+45)
	ldi ZH,HIGH(adr_DCF_BEREICH+45)
	rcall FUNCTION_DCF_BIT_01	; 45
	rcall FUNCTION_DCF_BIT_02	; 46
	rcall FUNCTION_DCF_BIT_04	; 47
	rcall FUNCTION_DCF_BIT_08	; 48
	rcall FUNCTION_DCF_BIT_10	; 49
	; MONAT bernehmen				
	STS(adr_DCF_MONAT),temp1
	; Fehlerprfung MONAT 1...12	
	tst temp1
	breq DCF_ZEIT_49_ERROR
	cpi temp1,(12+1)
	brlo DCF_ZEIT_49_OK
	; ERROR							
DCF_ZEIT_49_ERROR:
	ldi temp,(ERROR_DCF_MONAT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_49_OK:
;---------------------------------------------------------------------------
;50-57 		 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 				
DCF_ZEIT_50:
	clr temp1	; BIT					
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+50)
	ldi ZH,HIGH(adr_DCF_BEREICH+50)
	rcall FUNCTION_DCF_BIT_01	; 50
	rcall FUNCTION_DCF_BIT_02	; 51
	rcall FUNCTION_DCF_BIT_04	; 52
	rcall FUNCTION_DCF_BIT_08	; 53
	rcall FUNCTION_DCF_BIT_10	; 54
	rcall FUNCTION_DCF_BIT_20	; 55
	rcall FUNCTION_DCF_BIT_40	; 56
	rcall FUNCTION_DCF_BIT_80	; 57
	; JAHR bernehmen			
	STS(adr_DCF_JAHR),temp1
	; Fehlerprfung Jahr 12...40
	cpi temp1,(40+1)		; <=40
	brlo DCF_ZEIT_57_OK
	cpi temp1,(12)		; >=12
	brsh DCF_ZEIT_57_OK
	; ERROR						
	ldi temp,(ERROR_DCF_JAHR)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_57_OK:
;---------------------------------------------------------------------------
;58 Paritt Datum 											
DCF_ZEIT_58:
	LDS temp,(adr_DCF_BEREICH+58)	; Paritt laden				
	cp temp,temp2					; Paritt vergleichen		
	breq DCF_ZEIT_58_OK
	; ERROR						
	ldi temp,(ERROR_DCF_PARITAET_DATUM)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_58_OK:
; --------------------------------------------------------------------------
	; DCF-ZEIT ist korrekt !!!		 
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	; DCF_GUELTIG				
	STS(adr_DCF_GUELTIG),EINS
	; DCF-ZEIGER NULL			
	STS(adr_DCF_ZEIGER),NULL
	; SEKUNDEN					
	STS(adr_ss),NULL
	; MINUTEN					
	LDS temp,(adr_DCF_mm) 				; aus SRAM laden	
	STS (adr_mm),temp					; in SRAM speichern	
	; STUNDEN					
	LDS temp,(adr_DCF_hh) 				; aus SRAM laden	
	STS (adr_hh),temp					; in SRAM speichern	
	; TAG						
	LDS temp,(adr_DCF_TAG) 				; aus SRAM laden	
	STS (adr_TAG),temp					; in SRAM speichern	
	; Wochentag					
	LDS temp,(adr_DCF_WOCHENTAG) 		; aus SRAM laden	
	STS (adr_WOCHENTAG),temp			; in SRAM speichern	
	; MONAT						
	LDS temp,(adr_DCF_MONAT) 			; aus SRAM laden	
	STS (adr_MONAT),temp				; in SRAM speichern	
	; JAHR						
	LDS temp,(adr_DCF_JAHR) 			; aus SRAM laden	
	STS (adr_JAHR),temp					; in SRAM speichern	
	; MESZ						
	LDS temp,(adr_DCF_MESZ) 			; aus SRAM laden	
	STS (adr_MESZ),temp					; in SRAM speichern	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; Wertigkeit + Paritt berechnen											
; 1, 2, 4, 8, 10, 20, 40, 80												
; INP/OUT: Z																
; INP/OUT: temp1															
FUNCTION_DCF_BIT_01:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-1 ; +1	
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_02:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-2 ;+2	
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_04:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-4 ;+ 4
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_08:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-8 ;+ 8
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_10:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-10 ;+ 10
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_20:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-20 ;+ 20
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_40:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-40 ;+ 40
	rjmp FUNCTION_DCF_BIT_PARITAET
FUNCTION_DCF_BIT_80:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-80 ;+ 80
	rjmp FUNCTION_DCF_BIT_PARITAET
; --------------------------------------------------------------------------
FUNCTION_DCF_BIT_PARITAET:
	add temp2,EINS			; Paritt+1
	andi temp2,0b00000001 	; BITMUSTER
	ret
; --------------------------------------------------------------------------
FUNCTION_DCF_BIT_FERTIG:
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
