; ##############################################################################
; ##############################################################################
; ##############################################################################
Watchdog_aktivieren:
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; DDR (EINGANG) abfragen			
	sbic  (DCF_DDR) ,(DCF_PIN_NR) 						; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER	
	; DDR (AUSGANG) LED abfragen		
	sbis  (LED_DCF_GRUEN_DDR),(LED_DCF_GRUEN_PIN_NR) 	; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (LED_DCF_GELB_DDR),(LED_DCF_GELB_PIN_NR) 		; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (LED_DCF_ROT_DDR),(LED_DCF_ROT_PIN_NR) 		; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (LED_DCF_BLAU_DDR),(LED_DCF_BLAU_PIN_NR) 		; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	; DDR (AUSGANG) DIG abfragen		
	sbis  (PORT_DDR_DIG_1),(PIN_DIG_1) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_2),(PIN_DIG_2) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_3),(PIN_DIG_3) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_4),(PIN_DIG_4) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_5),(PIN_DIG_5) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_6),(PIN_DIG_6) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	; DDR (AUSGANG) BALKEN abfragen		
	sbis  (PORT_DDR_BALKEN_A),(PIN_BALKEN_A) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_B),(PIN_BALKEN_B) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_C),(PIN_BALKEN_C) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_D),(PIN_BALKEN_D) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_E),(PIN_BALKEN_E) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_F),(PIN_BALKEN_F) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_G),(PIN_BALKEN_G) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_P),(PIN_BALKEN_P) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER

	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM		
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER	
	ret
PROGRAMM_CHECK_FEHLER:
	;LED_BLINKEN
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	rcall wait_100ms
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	rcall wait_100ms
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG	
	sbi (LED_DCF_GRUEN_DDR),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_GELB_DDR),(LED_DCF_GELB_PIN_NR)  	; DCF-GELB	
	sbi (LED_DCF_ROT_DDR),(LED_DCF_ROT_PIN_NR)		; DCF-ROT	
	sbi (LED_DCF_BLAU_DDR),(LED_DCF_BLAU_PIN_NR)	; DCF-BLAU	
	sbi (RELAIS_DDR),(RELAIS_PIN_NR)				; RELAIS	
	; LEDs an		
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	cbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)		; DCF-ROT	
	cbi (LED_DCF_BLAU_PORT),(LED_DCF_BLAU_PIN_NR)	; DCF-BLAU	
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)				; RELAIS aus
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	; AUS			
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	sbi (LED_DCF_BLAU_PORT),(LED_DCF_BLAU_PIN_NR)	; DCF-BLAU	
	; AN			
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	rcall wait_100ms
	cbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	rcall wait_100ms
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	rcall wait_100ms
	cbi (LED_DCF_BLAU_PORT),(LED_DCF_BLAU_PIN_NR)	; DCF-BLAU	
	rcall wait_100ms
	; AUS			
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	sbi (LED_DCF_BLAU_PORT),(LED_DCF_BLAU_PIN_NR)	; DCF-BLAU	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_RELAIS_KLICK:
	; DCF schon erfolgreich ?	
	LDS temp,(adr_DCF_ERFOLGREICH)
	tst temp
	brne BERECHNUNG_RELAIS_KLICK_w
	ret
BERECHNUNG_RELAIS_KLICK_w:	
	; Nachtruhe	!				
	LDS temp,(adr_hh)
	cpi temp,0
	breq BERECHNUNG_RELAIS_KLICK_w1
	cpi temp,7
	brsh BERECHNUNG_RELAIS_KLICK_w1
	ret
BERECHNUNG_RELAIS_KLICK_w1:
	LDS temp,(adr_mm)
	tst temp
	breq BERECHNUNG_RELAIS_KLICK_w2
	ret
BERECHNUNG_RELAIS_KLICK_w2:
	LDS temp,(adr_ss)
	tst temp
	breq BERECHNUNG_RELAIS_KLICK_w3
	ret
BERECHNUNG_RELAIS_KLICK_w3:
	rcall RELAIS_KLICK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RELAIS_KLICK:
	cbi (RELAIS_PORT),(RELAIS_PIN_NR)				; RELAIS	
	rcall wait_100ms
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)				; RELAIS	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_HELLIGKEIT:
	; DCF gltig ?	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	breq BERECHNUNG_HELLIGKEIT_HELL
	; Nachtruhe ?	
	LDS temp,(adr_hh)
	cpi temp,6+1
	brlo BERECHNUNG_HELLIGKEIT_DUNKEL
	cpi temp,22
	brsh BERECHNUNG_HELLIGKEIT_DUNKEL
BERECHNUNG_HELLIGKEIT_HELL:
	ldi temp,6
	STS(adr_LED_HELLIGKEITSWERT),temp
	ret
BERECHNUNG_HELLIGKEIT_DUNKEL:
	ldi temp,25
	STS(adr_LED_HELLIGKEITSWERT),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
