; DCF77-MODUL (Samlingverfahren)				
; Bernhard.Erfurt@gmx.de						
; 10/2012										
;												
; 16 MHz										
; 4..6 x 7 Segment								
;												

; - Die Software erkennt automatisch invertierende und nichtinvertierende DCF77 Module														
;   Im Programmcode kann zwischen Automatikmodus, Invertiermodus und Nichtinvertiermodus umprogrammiert werden								
;   Kurz nach Programmstart wird im Automatikmodus das DCF-Ausgangssignal vom Modul untersucht												
;   und in die entsprechende Betriebsart (invertieren/nicht invertieren) umgeschaltet.														
;   Wurde das DCF-Protokoll erfolgreich empfangen lsst die Software keine Betriebsartumschaltung mehr zu, erst beim nchsten Programmstart.
;																											
; - Bei Bedarf kann die Strunterdrckung (DISPLAY-Abschaltung) aktiviert werden			
; - Die gelbe LED kann auf Dauerblinkmodus umgestellt werden								


; Anschlussbelegung PINS						
;												
; PB0 ==> (s.Anschlussbelegung)					
; PB1 ==> (s.Anschlussbelegung)					
; PB2 ==> (s.Anschlussbelegung)					
; PB3 ==> (s.Anschlussbelegung)					
; PB4 ==> (s.Anschlussbelegung)					
; PB5 ==> (s.Anschlussbelegung)					
; PB6 ==> Quarz	16MHz							
; PB7 ==> Quarz	16MHz							
;												
; PC0 ==> LED DCF-BLAU (DCF TESTAUSGANG			
; PC1 ==> RELAIS (STUNDEN-KLICK)				
; PC2 ==> DCF-EINGANG							
; PC3 ==> LED DCF-GRN (DCF gltig)				
; PC4 ==> LED DCF-GELB (DCF Eingangssignal)		
; PC5 ==> LED DCF-ROT  (Uhr heute noch nicht gestellt)	
;												
; PD0 ==> (A-s.Anschlussbelegung)				
; PD1 ==> (B-s.Anschlussbelegung)				
; PD2 ==> (C-s.Anschlussbelegung)				
; PD3 ==> (D-s.Anschlussbelegung)				
; PD4 ==> (E-s.Anschlussbelegung)				
; PD5 ==> (F-s.Anschlussbelegung)				
; PD6 ==> (G-s.Anschlussbelegung)				
; PD7 ==> (P-s.Anschlussbelegung)				
;												


; ATmega8 										
.include "m8def.inc"
; TIMER-WERTE									
.equ TIMERWERT1								=65536-250	;(2 hoch 16 minus....) bei 16MHz  => 0,001s=1ms 			
; DCF-PHASE_TIMERWERT (typ. 6s)					
.equ DCF_PHASE_TIMERWERT					= 6			; (1...20) nach einigen Sekunden Phase schieben				
; DCF-LED GELB (BLINKMODUS)						
.equ DCF_SIGNAL_LED_GELB_AN					= 0			; 0=aus 1=EIN(LED zeigt immer Eingangssignal an)			
; 7-SEGMENT- STRUNTERDRCKUNG					
.equ DCF_DISPLAY_STOERUNTERDRUECKUNG		= 0			; 0=aus 1=EIN												
; DCF-PIN-INVERTIERMODUS						
.equ DCF_EINGANG_VOREINSTELLUNG_INVERTIEREN	= 255		; 0=nicht invertieren 1=invertieren 255=Automatik			
; DCF-EINGANG									
.equ DCF_PIN_NR						= 2
.equ DCF_DDR						= DDRC
.equ DCF_PORT						= PORTC
.equ DCF_PIN						= PINC
; RELAIS										
.equ RELAIS_PIN_NR					= 1
.equ RELAIS_DDR						= DDRC
.equ RELAIS_PORT					= PORTC
; LED-DCF-GRUEN									
.equ LED_DCF_GRUEN_PIN_NR			= 3
.equ LED_DCF_GRUEN_DDR				= DDRC
.equ LED_DCF_GRUEN_PORT				= PORTC
; LED-DCF-GELB									
.equ LED_DCF_GELB_PIN_NR			= 4
.equ LED_DCF_GELB_DDR				= DDRC
.equ LED_DCF_GELB_PORT				= PORTC
; LED-DCF-ROT									
.equ LED_DCF_ROT_PIN_NR				= 5
.equ LED_DCF_ROT_DDR				= DDRC
.equ LED_DCF_ROT_PORT				= PORTC
; LED-DCF-BLAU									
.equ LED_DCF_BLAU_PIN_NR			= 0
.equ LED_DCF_BLAU_DDR				= DDRC
.equ LED_DCF_BLAU_PORT				= PORTC
; DCF-ERROR-CODES								
.equ ERROR_DCF_TURBO					= 20
.equ ERROR_DCF_MINUTENSTART				= 60
.equ ERROR_DCF_STOERIMPULSE				= 88

.equ ERROR_DCF_NO_ANFANGSBIT			= 100

.equ ERROR_DCF_RESERVEANTENNE			= 215	; nur INFO, kein ERROR	
.equ ERROR_DCF_ZEITUMSTELLUNG			= 216	; nur INFO, kein ERROR	

.equ ERROR_DCF_MESZ						= 118
.equ ERROR_DCF_SCHALTSEKUNDE			= 119
.equ ERROR_DCF_NO_ZEITINFORMATIONSBIT	= 120
.equ ERROR_DCF_MINUTE					= 127
.equ ERROR_DCF_PARITAET_MINUTE			= 128
.equ ERROR_DCF_STUNDE					= 134
.equ ERROR_DCF_PARITAET_STUNDE			= 135
.equ ERROR_DCF_TAG						= 141
.equ ERROR_DCF_WOCHENTAG				= 144
.equ ERROR_DCF_MONAT					= 149
.equ ERROR_DCF_JAHR						= 157
.equ ERROR_DCF_PARITAET_DATUM			= 158

; ZEICHEN-DARSTELLUNG - 7-SEGMENT				
.equ ZAHL_0					=0b00111111	; 0 
.equ ZAHL_1					=0b00000110	; 1 
.equ ZAHL_2					=0b01011011	; 2 
.equ ZAHL_3					=0b01001111	; 3 
.equ ZAHL_4					=0b01100110	; 4 
.equ ZAHL_5					=0b01101101	; 5 
.equ ZAHL_6					=0b01111101	; 6 
.equ ZAHL_7					=0b00000111	; 7 
.equ ZAHL_8					=0b01111111	; 8 
.equ ZAHL_9					=0b01101111	; 9 

.equ ZEICHEN_AUS			=0b00000000	; ''
.equ ZEICHEN_PUNKT			=0b10000000	; . 
.equ ZEICHEN_VOLL			=0b11111111	; 8.
.equ ZEICHEN_MINUS			=0b01000000	; - 

.equ ZEICHEN_A				=0b01110111	; A 
.equ ZEICHEN_B				=0b01111100	; B 
.equ ZEICHEN_C				=0b01011000	; C 
.equ ZEICHEN_D				=0b01011110	; D 
.equ ZEICHEN_E				=0b01111001	; E 
.equ ZEICHEN_F				=0b01110001	; F 


; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=0x0060				; 0x0060 START Adresse 						

.equ adr_FREIGABE_PROGRAMM		=0x0060+0			; fr Display								

.equ adr_TASTE					=0x0060+2			; Tastenwert								

.equ adr_LED_HELLIGKEITSWERT	=0x0060+10			; HELLIGKEIT (6...40)
.equ adr_LED_DIGIT_ZAEHLER		=0x0060+11			; interner Zhler	
.equ adr_LED_BYTE_0				=0x0060+12			; DIGIT				
.equ adr_LED_BYTE_1				=0x0060+13			; DIGIT				
.equ adr_LED_BYTE_2				=0x0060+14			; DIGIT				
.equ adr_LED_BYTE_3				=0x0060+15			; DIGIT				
.equ adr_LED_BYTE_4				=0x0060+16			; DIGIT				
.equ adr_LED_BYTE_5				=0x0060+17			; DIGIT				

.equ adr_ssVT					=0x0060+120			; Vorteiler
.equ adr_ss100					=0x0060+121			; 100-el	
.equ adr_ss						=0x0060+122			; Sekunden	
.equ adr_mm						=0x0060+123			; Minuten	
.equ adr_hh						=0x0060+124			; Stunden	
.equ adr_TAG					=0x0060+125			; Tag		
.equ adr_WOCHENTAG				=0x0060+126			; WochenTag	
.equ adr_MONAT					=0x0060+127			; Monat		
.equ adr_JAHR					=0x0060+128			; Jahr		
.equ adr_MESZ					=0x0060+129			; MESZ		

.equ adr_DCF_mm					=0x0060+200			; Minuten 	aus DCF-Protokoll	
.equ adr_DCF_hh					=0x0060+201			; Stunden 	aus DCF-Protokoll	
.equ adr_DCF_TAG				=0x0060+202			; Tag	 	aus DCF-Protokoll	
.equ adr_DCF_WOCHENTAG			=0x0060+203			; WochenTag aus DCF-Protokoll	
.equ adr_DCF_MONAT				=0x0060+204			; Monat	 	aus DCF-Protokoll	
.equ adr_DCF_JAHR				=0x0060+205			; Jahr	 	 aus DCF-Protokoll	
.equ adr_DCF_MESZ				=0x0060+206			; SOMMERZEIT aus DCF-Protokoll	

.equ adr_DCF_PIN_INVERTIERMODUS	=0x0060+210			; 1=EINGANSPEGEL invertieren	
.equ adr_DCF_PIN_WERT			=0x0060+211			; fr auto INVERTIERMODUS		
.equ adr_DCF_PIN_WERT_OLD		=0x0060+212			; fr auto INVERTIERMODUS		

.equ adr_DCF_SAMPLES_A			=0x0060+220			; SAMPLES_A (100ms)				
.equ adr_DCF_SAMPLES_B			=0x0060+221			; SAMPLES_B (200ms)				
.equ adr_DCF_BIT				=0x0060+222			; DCF-BIT aus SAMPLES A+B		

.equ adr_DCF_IMPULS_OLD			=0x0060+230			; OLD-WERT						
.equ adr_DCF_IMPULS_PHASE		=0x0060+231			; PHASE							
.equ adr_DCF_PHASE_TIMER		=0x0060+232			; TIMER fr PHASE				

.equ adr_DCF_ZEIGER				=0x0060+240			; Zeiger fr DCF-FELD			
.equ adr_DCF_ERFOLGREICH		=0x0060+241			; DCF nach PROGRAMMSTART erfolgreich empfangen	
.equ adr_DCF_GUELTIG			=0x0060+242			; DCF-Protokoll ist geprft und gltig			
.equ adr_DCF_ERROR_CODE			=0x0060+243			; DCF-ERROR-CODE				

.equ adr_DCF_BEREICH			=0x0060+250	 		; 60 BYTES fr DCF-FELD			

.equ adr_SRAM_CHECK				=0x0060+900			; Programm-Check				


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   		; IRQ0 Handler                  
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF  			; Timer1 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Interrupt-ERROR ==> blinken						
INTERRUPT_ERROR:
	cbi (LED_DCF_GRUEN_DDR),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	cbi (LED_DCF_GELB_DDR),(LED_DCF_GELB_PIN_NR)  	; DCF-GELB	
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; ROTDCF	
	rcall wait_100ms
	sbi (LED_DCF_GRUEN_DDR),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_GELB_DDR),(LED_DCF_GELB_PIN_NR)  	; DCF-GELB	
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; ROTDCF	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM CLEAR										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	
; PORT B initialisieren								
	ldi temp, 0b00000000	
	out DDRB, temp
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	
	out DDRC, temp
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000
	out DDRD, temp			
	out PORTD, temp				
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; LED_7SEGMENT_INITIALISIERUNG						
	rcall LED_7SEGMENT_INITIALISIERUNG
; Watchdog aktivieren (max. Zeit)					
	rcall Watchdog_aktivieren
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED_TEST											
	rcall LED_TEST
; TIMER1_INITIALISIERUNG							
	rcall TIMER1_INITIALISIERUNG
; TIMER aktivieren									
	rcall TIMER_AKTIVIEREN
; Startwerte										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; ZEIT hh			
	ldi temp,0
	STS(adr_hh),temp
	; ZEIT mm			
	ldi temp,0
	STS(adr_mm),temp
	; ZEIT ss			
	ldi temp,0
	STS(adr_ss),temp
	; DATUM				
	ldi temp,1
	STS(adr_TAG),temp
	ldi temp,1
	STS(adr_MONAT),temp
	ldi temp,1
	STS(adr_JAHR),temp
	ldi temp,7
	STS(adr_WOCHENTAG),temp
	; DCF-PHASE-TIMERWERT (3s)	
	ldi temp,3
	STS(adr_DCF_PHASE_TIMER),temp
	; SRAM-CHECK				
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; HELLIGKEIT (6...ca.30)	
	ldi temp,6
	STS(adr_LED_HELLIGKEITSWERT),temp

; EEPROM_KONFIGURATION_LADEN						
	rcall EEPROM_KONFIGURATION_LADEN
; DCF_INITIALISIERUNG								
	rcall DCF_INITIALISIERUNG
; interrupts freigeben								
	sei
; sonstiges											
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	aus				
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)		; DCF-ROT	an				
	rcall RELAIS_KLICK								; RELAIS-KLICK				
; LED_7SEGMENT_TEST									
	rcall LED_7SEGMENT_TEST_A
	rcall wait_1s
	rcall LED_7SEGMENT_TEST_B
	rcall wait_1s
	rcall LED_7SEGMENT_TEST_C
	rcall wait_1s
	rcall LED_ALLE_AUS
	rcall wait_1s
	rcall LED_VERSION_ANZEIGEN
	rcall wait_1s
	rcall wait_1s
	rcall LED_ALLE_AUS
	rcall wait_1s
	STS(adr_DCF_ERROR_CODE), NULL
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp 
	breq LOOP
;-------------------------------------------------------------------------------
	STS(adr_FREIGABE_PROGRAMM),NULL
	rcall DCF_BESTIMMUNG_ERFOLGREICH
	rcall DCF_AUTO_INVERTIERMODUS_ERKENNUNG
	rcall BERECHNUNG_RELAIS_KLICK
	rcall BERECHNUNG_HELLIGKEIT
	rcall MENUE
	rcall PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; STERUNTERDRCKUNG ?				
	ldi temp,(DCF_DISPLAY_STOERUNTERDRUECKUNG)
	tst temp
	breq MENUE_OHNE_SU
;-------------------------------------------------------------------------------
MENUE_MIT_SU:
	; um 03:00...03:15Uhr das DISPLAY abschalten	
	LDS temp,(adr_hh)	
	cpi temp,3
	brne MENUE_MIT_ER
	LDS temp,(adr_mm)	
	cpi temp,15
	brsh MENUE_MIT_ER
	rjmp MENUE_AUS
MENUE_MIT_ER:
	; Uhr schon erfolgreich gestellt ?	
	LDS temp,(adr_DCF_ERFOLGREICH)
	tst temp
	breq MENUE_AUS
	rjmp MENUE_RUN
MENUE_AUS:
	rcall LED_ALLE_AUS
ret
;-------------------------------------------------------------------------------
MENUE_OHNE_SU:
	; Uhr schon erfolgreich gestellt ?
	LDS temp,(adr_DCF_ERFOLGREICH)
	tst temp
	brne MENUE_RUN
	; ERROR anzeigen	
	LDS temp,(adr_DCF_ERROR_CODE)
	tst temp
	breq MENUE_OHNE_SU_Z
	LDS temp,(adr_ss)
	cpi temp,5
	breq MENUE_E
	cpi temp,10
	breq MENUE_E
	cpi temp,15
	breq MENUE_E
	cpi temp,20
	breq MENUE_E
	cpi temp,25
	breq MENUE_E
	cpi temp,30
	breq MENUE_E
MENUE_OHNE_SU_Z:
	rcall LED_ZEIT_ANZEIGEN
	ret
MENUE_E:
	rcall LED_ERROR_ANZEIGEN
	ret
;-------------------------------------------------------------------------------
MENUE_RUN:
	; Z initialisieren	
	LDS temp,(adr_ss)
	ldi ZL,LOW (MENUE_SPRUNGMARKE)
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	add ZL,temp 
	adc ZH,NULL
	; SPRUNG nach Z		
	ijmp
MENUE_SPRUNGMARKE:
	rjmp LED_ZEIT_ANZEIGEN		; 0
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN

	rjmp LED_ZEIT_ANZEIGEN		; 10
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_DATUM_ANZEIGEN
	rjmp LED_DATUM_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN

	rjmp LED_ZEIT_ANZEIGEN		; 20
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN

	rjmp LED_DATUM_ANZEIGEN		; 30
	rjmp LED_DATUM_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN

	rjmp LED_ZEIT_ANZEIGEN		; 40
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_DATUM_ANZEIGEN
	rjmp LED_DATUM_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN

	rjmp LED_ZEIT_ANZEIGEN		; 50
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN
	rjmp LED_ZEIT_ANZEIGEN

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DCF_LED_TIMER.asm"
.include "DCF_LED_DCF.asm"
.include "DCF_LED_LED.asm"
.include "DCF_LED_LED_BELEGUNG6.asm"
.include "DCF_LED_EEPROM.asm"
.include "DCF_LED_SONSTIGES.asm"
.include "DCF_LED_16MHZwait.asm"







